/*
* Copyright (c) 2003, University of Maryland 
* Copyright (c) 2003, Center for Satellite and Hybrid Communication Networks 
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the University of Maryland/Center for Satellite
*     and Hybrid Communication Networks nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

/* Authors: 
*     Jonathan Polley (jpolley@isr.umd.edu),
*     Dionysus Blazakis (dblaze@isr.umd.edu),
*     Jonathan McGee (mcgee@isr.umd.edu),
*     Daniel Rusk (ruskd@isr.umd.edu),
*     Manish Karir (karir@isr.umd.edu)
*/

#ifndef XATDB_CALLBACKS_H
#define XATDB_CALLBACKS_H

#include <gtk/gtk.h>

void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_delete1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
button_step_clicked                    (GtkWidget *widget,
                                        gpointer   data);

void
button_cstep_clicked                   (GtkWidget *widget,
                                        gpointer   data);

void
button_go_clicked                      (GtkWidget *widget,
                                        gpointer   data);

void
button_stop_clicked                    (GtkWidget *widget,
                                        gpointer   data);

void
button_restart_clicked                 (GtkWidget *widget,
                                        gpointer   data);

void
button_set_break_clicked               (GtkWidget *widget,
                                        gpointer   data);

void
close_popups                            ( );

gboolean 
break_window_popup                     (GtkWidget *widget, 
                                        GdkEventButton *event,
                                        gpointer  data);

void
apply_breakpoint                       (GtkWidget *widget,
                                        gpointer   data);

void 
break_popup_clear_break                (GtkWidget *widget,
                                        gpointer data);

void
change_breakpoint_chip                 (GtkWidget *widget,
                                        gpointer   data);

void select_cfile(GtkWidget *widget, gpointer data);

void 
watch_popup_clear_watch                (GtkWidget *widget,
                                        gpointer data);
gboolean 
watch_window_popup                     (GtkWidget *widget, 
                                        GdkEventButton *event,
                                        gpointer  data);

void
button_set_watch_clicked               (GtkWidget *widget,
                                        gpointer   data);

gboolean on_window1_configure(GtkWidget *widget, GdkEventConfigure *event);
void vpane_change_position(GObject *object, GParamSpec *pspec, gpointer data);
void hpane_change_position(GObject *object, GParamSpec *pspec, gpointer data);
void notebook_chips_select(GtkNotebook *book, GtkNotebookPage *page, guint page_num, gpointer data);
void code_window_popup(GtkTextView *textview, GtkMenu *arg1, gpointer user_data);
void source_window_popup(GtkTextView *textview, GtkMenu *arg1, gpointer user_data);
gboolean cursor_to_click(GtkTextView *view, GdkEventButton *event, gpointer data);
gboolean click_globals(GtkWidget *tv, GdkEventButton *event, gpointer null);
gboolean click_locals(GtkWidget *tv, GdkEventButton *event, gpointer null);

#endif
